/* AP 05-04-04	gocc_exec.c					*/
/* 		execution of GridOccam statements in		*/
/*		multiple threads				*/


# include <unistd.h>
# include <pthread.h>
# include <stdarg.h>

# include "gocc_exec.h"

# ifndef NULL
# define NULL (void *)0
# endif

typedef void* (*PTHREAD_FUNC)(void*);

/* parallel execution of a series of GridOccam statements	*/
int par_exec( BlockT bp, ... ) {
	va_list ap;
	pthread_t thids[MaxParBlocks];
	int thcnt = 0, i;

	va_start( ap, bp );
	if (bp == NULL) {
		va_end( ap );
		return -1;
	}
	pthread_create( &thids[thcnt++], NULL, (PTHREAD_FUNC) bp, NULL );
	while ((bp = va_arg( ap, BlockT)) != NULL)
		pthread_create(&thids[thcnt++], NULL, (PTHREAD_FUNC) bp, NULL);

	va_end( ap );
	for (i = 0; i < thcnt; i++)
		pthread_join( thids[i], NULL );
	return 0;
}

/* sequential execution of a series of GridOccam statements	*/
int seq_exec( BlockT bp, ... ) {
	va_list ap;

	va_start( ap, bp );
	if (bp == NULL) {
		va_end( ap );
		return -1;
	}
	bp();
	while ((bp = va_arg( ap, BlockT)) != NULL) bp();

	va_end( ap );
	return 0;
}

